/********************************************************************************
  vpostproc/postproc.hh
    Video frame post processor.

  purpose:

  notes:

  to do:

  author(s):
   - Dirk Farin, Kapellenweg 15, 72070 Tuebingen, Germany,
     email: farindk@trick.informatik.uni-stuttgart.de

  modifications:
   19/Jan/99 - Dirk Farin
     - interface definition
 ********************************************************************************
    Copyright (C) 1999  Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef DVDVIEW_VPOSTPROC_POSTPROC_HH
#define DVDVIEW_VPOSTPROC_POSTPROC_HH

#include "video12/output.hh"
#include "vpostproc/buffer.hh"


class VideoPostprocessor : public DecodedPictureSink
{
public:
  VideoPostprocessor();
  virtual ~VideoPostprocessor();

  void SetNext(DecodedPictureSink* next)
    {
      d_next = next;
      Assert(d_next);
    }

  virtual void Render(DecodedImageData*) { }

  DecodedImageData* GetOutputBuffer(ImageSpec_YUV spec,uint3 picture_type,bool maymodify);
  void              ShowOutputBuffer(DecodedImageData*);
  void              FreeOutputBuffer(DecodedImageData*);

protected:
  class DecodedPictureSink* d_next;

private:
  static const int MaxReplacements=5;
  struct Replacement
  {
    ImageSpec_YUV     spec;
    uint3             pic_type;
    DecodedImageData* replacement;
  } *replacement;
  int nReplacements;

  static VideoImageBuffer s_bufprov;
};

#endif
